use std::io::{stdin, BufRead};

const NUM_TEST: [(&str, &str); 9] = [
    ("one", "1"),
    ("two", "2"),
    ("three", "3"),
    ("four", "4"),
    ("five", "5"),
    ("six", "6"),
    ("seven", "7"),
    ("eight", "8"),
    ("nine", "9"),
];

fn main() {
    let input = stdin().lock().lines().map(|l| l.unwrap());
    let mut part_one_total = 0;
    let mut part_two_total = 0;

    for line in input {
        part_one_total += part_one_calc(&line);
        part_two_total += part_two_calc(&line);
    }

    println!("P1: {} P2: {}", part_one_total, part_two_total);
}

fn part_two_calc(line: &str) -> usize {
    let mut line = String::from(line);

    for str in NUM_TEST {
        if line.contains(str.0) {
            let swap = str.0.to_string() + str.1 + str.0;
            line = line.replace(str.0, &swap);
        }
    }
    part_one_calc(&line)
}

fn part_one_calc(line: &str) -> usize {
    let mut nums = line.chars().filter(|c| c.is_numeric());
    let first = nums.next().unwrap_or('0');
    let last = nums.last().unwrap_or(first);
    format!("{}{}", first, last).parse().unwrap()
}
