use regex::Regex;
use std::io::{stdin, BufRead};

type Rgb = (usize, usize, usize);
const THRESHOLD: Rgb = (12, 13, 14);

fn main() {
    let re = Regex::new(r"\d+ (b|r|g)").unwrap();
    let input = stdin().lock().lines().map(|l| l.unwrap());
    let mut id_sum = 0;
    let mut water_sum = 0;

    for (i, line) in input.enumerate() {
        let mut possible = true;

        let mut max_rgb = (0, 0, 0);
        for line_sect in line.split(';') {
            let mut rgb = (0, 0, 0);

            let games = re
                .find_iter(line_sect)
                .map(|l| {
                    let temp = l.as_str().split_once(' ').unwrap();
                    (temp.0.parse::<usize>().unwrap(), temp.1)
                })
                .collect::<Vec<_>>();

            for game in games.iter() {
                match game.1 {
                    "r" => rgb.0 = game.0,
                    "g" => rgb.1 = game.0,
                    "b" => rgb.2 = game.0,
                    _ => (),
                }
                if rgb.0 > max_rgb.0 {
                    max_rgb.0 = rgb.0;
                }

                if rgb.1 > max_rgb.1 {
                    max_rgb.1 = rgb.1;
                }

                if rgb.2 > max_rgb.2 {
                    max_rgb.2 = rgb.2;
                }

                if possible && rgb.0 > THRESHOLD.0 || rgb.1 > THRESHOLD.1 || rgb.2 > THRESHOLD.2 {
                    possible = false;
                }
            }
        }

        let pow = max_rgb.0 * max_rgb.1 * max_rgb.2;
        water_sum += pow;

        if possible {
            id_sum += i + 1;
        }
    }
    println!("P1: {}, P2: {}", id_sum, water_sum);
}
